---
title: MediaSource.MediaSource()
slug: Web/API/MediaSource/MediaSource
tags:
  - API
  - Audio
  - Constructor
  - Experimental
  - MSE
  - Media Source Extensions
  - MediaSource
  - Reference
  - Video
---
<div>{{APIRef("Media Source Extensions")}}{{SeeCompatTable}}</div>

<p>The <code><strong>MediaSource()</strong></code> constructor of the {{domxref("MediaSource")}} interface constructs and returns a new <code>MediaSource</code> object with no associated source buffers.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>mediaSource</em> = new MediaSource();</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h2 id="Example">Example</h2>

<p>The following snippet is taken from a simple example written by Nick Desaulniers (<a href="https://nickdesaulniers.github.io/netfix/demo/bufferAll.html">view the full demo live</a>, or <a href="https://github.com/nickdesaulniers/netfix/blob/gh-pages/demo/bufferAll.html">download the source</a> for further investigation.)</p>

<pre class="brush: js">var video = document.querySelector('video');

var assetURL = 'frag_bunny.mp4';
// Need to be specific for Blink regarding codecs
// ./mp4info frag_bunny.mp4 | grep Codec
var mimeCodec = 'video/mp4; codecs="avc1.42E01E, mp4a.40.2"';

if ('MediaSource' in window &amp;&amp; MediaSource.isTypeSupported(mimeCodec)) {
  var mediaSource = new MediaSource;
  //console.log(mediaSource.readyState); // closed
  video.src = URL.createObjectURL(mediaSource);
  mediaSource.addEventListener('sourceopen', sourceOpen);
} else {
  console.error('Unsupported MIME type or codec: ', mimeCodec);
}

...
</pre>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.MediaSource.MediaSource")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("SourceBuffer")}}</li>
 <li>{{domxref("SourceBufferList")}}</li>
</ul>
